import com.haxepunk.HXP;
import com.haxepunk.Entity;

class Cell {
	public static var size: Int = 1000;

	public var x: Int;
	public var y: Int;
	public var loaded: Bool = false;
	public var objects: Array<Entity>;
	public var treasure: Bool = false;
	private var r2:Int;

	public function new(x:Int, y:Int) {
		this.x = x;
		this.y = y;
		objects = new Array<Entity>();
	}

	private function addTreasure(p:Float, x:Float, y:Float) {
		if(!treasure && y>150) {
			r2 = r2 * 1234 + 654321;
			HXP.world.add( new Chest(x, y) );
		}
	}

	public function load() {
		var seed:Int = (x * 0xffff + y) & 0x7fffffff;
		r2 = seed;
		HXP.randomSeed = seed;
		var count:Int = HXP.rand(12);
		//trace("load (" + x + ", " + y + ") : " + count + " [" + seed + "]");
		for(i in 0...count) {
			var type: Int = HXP.rand(3);
			var rx: Float = HXP.random * size + x*size;
			var ry: Float = HXP.random * size + y*size;
			var rock: Entity = new Rock(rx, ry, type);
			objects.push(rock);
			HXP.world.add(rock);

			// Treasure?
			if(type==2) {
				addTreasure( 0.8, rx+100, ry+20);
				addTreasure( 0.8, rx+rock.width-100, ry+20);
			}
			addTreasure( 0.4,  rx+rock.halfWidth, ry);
		}
		loaded = true;
		treasure = true;


		// Load some treasure
		count = 0;// HXP.rand(4);
		for(i in 0...count) {
			var tx: Float = HXP.random * size + x*size;
			var ty: Float = HXP.random * size + y*size;
			HXP.world.add( new Chest(tx, ty) );
		}
	}

	public function loadFish() {
		HXP.randomizeSeed();
		for(i in 0...20) {
			var tx: Float = HXP.random * size + x*size;
			var ty: Float = HXP.random * size + y*size;
			if(ty>200) {
				HXP.world.add( new Fish(tx, ty, "fish") );
			}
		}
	}

	public function unload() {
		//trace("unload (" + x + ", " + y + ")");
		for(o in objects) HXP.world.remove(o);
		objects = [];
		loaded = false;
	}

}



