
import com.haxepunk.HXP;
import com.haxepunk.Entity;
import com.haxepunk.graphics.Image;

class Chest extends Entity {
	
	public var light: Light;
	
	public function new(x:Float, y:Float) {
		super(x, y);
		graphic = new Image("graphics/chest.png");
		cast(graphic, Image).centerOrigin();
		setHitboxTo( graphic );

		light = new Light(40);
		light.brightness = 0.3;
		visible = false;
		type = "treasure";
	}

	public override function removed() {
		cast(world, MainScene).lighting.removeLight( light );
	}


	public override function update() {

		if(!visible) {
			if(collide("solid", x, y)!=null) world.remove(this);
			else {
				var ty:Float = Math.floor(y/Cell.size) * Cell.size + Cell.size;
				moveTo(x, ty, "solid", true);
				y += 12;
				light.x = x; light.y=y;
				cast(world, MainScene).lighting.addLight( light );
			}
			visible = true;
		}

	}

}


