import com.haxepunk.HXP;
import flash.display.GradientType;
import flash.display.BlendMode;
import flash.geom.Matrix;



class Lighting {

	public var lights: Array<Light> = new Array<Light>();
	public var scale: Float = 0.001;

	public function new() {
		
	}

	public function addLight(light:Light) {
		lights.push( light );
	}

	public function removeLight(light:Light) {
		lights.remove(light);
	}

	public function render() {
		HXP.sprite.graphics.clear();

		// Depth lighting
		HXP.matrix.createGradientBox(HXP.width, 2000, Math.PI/2, 0, -HXP.camera.y);
		HXP.sprite.graphics.beginGradientFill(GradientType.LINEAR, [0xffffff, 0], [1,1], [0,255], HXP.matrix);
		HXP.sprite.graphics.drawRect(0,0, HXP.width, HXP.height);
		HXP.sprite.graphics.endFill();
		
		// Other lights
		for(l in lights) {
			var ls: Float = l.radius * 2;
			var lx: Float = l.x + l.ox - l.radius - HXP.camera.x;
			var ly: Float = l.y + l.oy - l.radius - HXP.camera.y;
			if(lx+ls>0 && ly+ls>0 && lx<HXP.width && ly<HXP.height) {
				HXP.matrix.createGradientBox(ls, ls, 0, lx, ly);
				HXP.sprite.graphics.beginGradientFill(GradientType.RADIAL, [0xffffff, 0xffffff], [l.brightness,0], [0,255], HXP.matrix);
				HXP.sprite.graphics.drawRect(lx,ly, ls, ls);
				HXP.sprite.graphics.endFill();
			}
		}

		HXP.buffer.draw(HXP.sprite, BlendMode.MULTIPLY);
	}


}

